# Téléphone jukebox

Les instructions qui suivent ont été testées avec des Teensy versions 3.1 et 4.0 (et les modules audio correspondant).

## Électronique

* Souder le Teensy sur la carte audio. Le plus compact est de les empiler à l'aide de broches. Faites bien attention à les mettre dans le bon sens (les noms des pins doivent correspondre). Il n'est pas nécessaire de connecter les pins 0 à 5.
* Ouvrir le boîtier du téléphone par les deux vis du dessous
* Positionner le boulon de réglage glissant sur "3/MINI" (s'il existe sur votre modèle)
* Relier le GND du Teensy (un trou libellé "G" ou "GND" sur la carte audio) au fil rouge-blanc du cadran (boulon II)
* Relier le fil rouge-blanc du cadran (boulon II) au fil jaune de la prise en T (boulon 15)
* Relier le pin 2 du Teensy au fil blanc de la prise en T (boulon 11)
* Relier le VGND du module audio (pad de la prise jack le plus vers l'extérieur, dans le coin de la carte) au fil bleu du combiné (boulon 3)
* Relier le canal droit ou gauche de la prise jack (un trou libellé L ou R à côté de la prise jack) au fil rouge du combiné (boulon 5)

Si les fils sont cassants (monobrins), je conseille de les enrouler autour du manchon en métal de la patte qui est fixée au boulon, plutôt que de l'enrouler autour de la vis serrée avec le boulon, afin d'éviter de trop contraindre le fil.

Attention, GND et VGND ne doivent pas être reliés.

## Logiciel

Programmer le Teensy avec le programme fourni.

## Finition

* Fabriquer le boîtier d'isolation du Teensy à l'aide d'une imprimante 3D (`teensy_case.stl`), et le placer sur le Teensy (il peut être fixé avec des boulons M3).
* Si besoin, faire un petit trou dans la coque du téléphone pour faire passer le câble USB (ce qui permet l'alimentation et la programmation facilement).
* Indiquer quelque part sur l'appareil les informations nécessaires à son utilisation ou son amélioration futures (par exemple l'adresse de ce dépôt).

## Utilisation

### Fichiers audio

Les fichiers doivent être au format WAV, taux d'échantillonnage (sampling rate) 44100Hz, 16bit. Les noms des fichiers doivent être de `0.wav` à `9.wav`, ce qui correspond aux chiffres du cadran.

Le son peut être en stéréo, mais un seul des deux canaux sera joué.

Pour convertir un fichier audio :
* Ouvrir le fichier avec Audacity
* Sélectionner la piste en cliquant dessus
* Menu "Pistes" -> "Rééchantillonner"
* Sélectionner "44100" puis Valider
* Menu "Fichier" -> "Exporter" -> "Exporter en WAV"
* Choisir l'encodage "Signed 16-bit PCM" et enregistrer le fichier.

La conversion peut également être effectuée en ligne de commande :
```bash
ffmpeg -i FICHIER_EXISTANT -y -ar 44100 -ac 1 -aq 16 CHIFFRE.wav
```

### Partitionnement

Si le Teensy n'arrive pas à lire la carte SD (ce qui est signalé par un bip toutes les 2 secondes), vérifier le partitionnement, qui doit être FAT32 (et non FAT16, par exemple).

## Améliorations

Pistes d'amélioration qui n'ont pas encore été réalisées :

* Les deux sorties L/R pourraient être utilisées pour contrôler deux téléphones. Le Teensy pourrait alors être dans un boîtier externe, relié aux téléphones par leur prise en T (moyennant un recâblage minime à l'intérieur des téléphones).
* Faire sonner la cloche ?
* Numéros à plusieurs chiffres. Cela nécessite la détection de la fin de la numérotation, soit avec un nombre fixé de chiffres, soit avec un timeout, soit avec des règles de numérotation spéciales, éventuellement avec découverte des fichiers sur la carte SD.
* Microcontrôleur moins cher ? (par exemple un ATtiny, mais à voir pour l'audio/SD)
* Interaction avec un ordinateur et une carte son (permet plus de complexité et déleste le microcontrôleur de la gestion du son)

## Licence

CopyLeft 2022 Pascal Engélibert

Ces instructions sont mises à disposition selon les termes de la licence [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/).

Merci à la compagnie [Léna d'Azy](https://www.lenadazy.fr/) d'avoir financé la conception et la documentation.
